import java.util.*;
import javax.management.*;
import org.jboss.jmx.interfaces.*;
import org.jboss.jmx.client.*;
import org.jboss.monitor.client.*;

public class JMXClient
{
	public static void main(String[] args)
	{
		try
		{
			if (args.length != 1)
			{
				System.out.println("Missing JBoss' host name. Use jndiView and look for jmx:<host name>:rmi.");
				System.exit(1);
			}

			java.io.InputStream jndi = JMXClient.class.getResourceAsStream("/defaultjndi.properties");
			Properties p = new Properties();
			p.load(jndi);
			for (Enumeration i = p.keys(); i.hasMoreElements();)
			{
				String key = (String)i.nextElement();
				String val = (String)p.get(key);
				System.setProperty(key, val);
				System.out.println(key + ", " + val);
			}

			JMXConnector connector = new RMIClientConnectorImpl(args[0]);
			while (true)
			{
				BeanCacheSnapshot[] snapshots = (BeanCacheSnapshot[])connector.invoke(new ObjectName("Monitor:name=BeanCacheMonitor"), "getSnapshots", new Object[] {}, new String[] {});
				for (int i = 0; i < snapshots.length; ++i)
				{
					System.out.println(snapshots[i]);
					System.out.println();
				}
				Thread.sleep(3000);
			}
		}
		catch (Exception x)
		{
			x.printStackTrace();
			if (x instanceof RuntimeMBeanException)
			{
				((RuntimeMBeanException)x).getTargetException().printStackTrace();
			}
		}
	}
}